#include "CausticCasterRenderTechnique.h"

CausticCasterRenderTechnique::CausticCasterRenderTechnique(unsigned long startFrame,
												unsigned long photonMapUpdateInterval,
												unsigned int photonMapResolution,
												unsigned int causticCubeMapResolution,
												bool updateAllFace,
												bool useDistance,
												ElementaryRenderable* parentRenderable,
												TechniqueGroup* parentTechniqueGroup)
							:RenderTechnique( parentRenderable, parentTechniqueGroup)
{
	this->useDistance = useDistance;
	this->photonMapUpdateInterval = photonMapUpdateInterval;
	this->photonMapResolution = photonMapResolution;
	this->causticCubeMapResolution = causticCubeMapResolution;
	this->startFrame = startFrame;	
	this->updateAllFace = updateAllFace;
}

CausticCasterRenderTechnique::~CausticCasterRenderTechnique()
{

}

void CausticCasterRenderTechnique::runChanged(RenderingRunType runType, RenderingRun* run)
{
	if(runType == ILLUMRUN_PHOTONMAP)
		photonMapRunChanged(run);
	if(runType == ILLUMRUN_CAUSTIC_CUBEMAP)
		causticCubeMapRunChanged(run);
	if(runType == ILLUMRUN_DISTANCE_CUBEMAP)
		distanceCubeMapRunChanged(run);	
}

void CausticCasterRenderTechnique::runUpdated(RenderingRunType runType, RenderingRun* run)
{
	if(runType == ILLUMRUN_DISTANCE_CUBEMAP)
		distanceCubeMapRunUpdated(run);
}


